<?php
// 系統整合付款, 由特店購物車記錄交易訂單編號及金額後, 轉送台灣里付款服務處理付款事宜.
// 若特店於付款要求中指定 return_url , 消費者付完款或開完離線付款單後會將瀏覽器導回 return_url .

require_once( __DIR__.DIRECTORY_SEPARATOR."openpay_config.php" );
session_start();

$fparam = $_REQUEST;

switch( $fparam['step'] ) {
case 'callback':
  $res_param = $fparam;
  $is_valid = OpenpayManager::verifyInterPayResponse( $res_param['txid'], $res_param['amount'], $res_param['pay_type'], $res_param['status'], $res_param['tid'], $res_param['verify'] );

  $req_param = $_SESSION[$res_param['txid']];

  if( $req_param['amount'] != $res_param['amount'] )
    throw new Exception( "request amount not match with response amount.");

  $display = "result";
  break;

default:
  try {
    $txid   = date("mdHis");
    $amount = rand( 101, 120 );
    $return_url = (isset($_SERVER["HTTPS"]) ? 'https' : 'http').'://'.$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'].'?step=callback';
    $description_tchinese  = "測試付款";
    $description_schinese  = "测试付款";
    $description_english   = "Test Payment";
    $cart_type             = "sample cart";
    $cid                   = "A123456789";
    $cname                 = "李三";
    $caddress              = "台南市中正區中山路1號";
    $ctel                  = "0911222333";
    $cemail                = "test@customer.com";
    $xtype                 = 1;
    $xname                 = "";
    $xaddress              = "";
    $xtel                  = "";
    $pcsccod_recv_store_id = "";

    $_SESSION[$txid] = array( 'txid' => $txid, 'amount' => $amount );

    $pay_action = OpenpayManager::getInterPayRequest( $txid, $amount, 1, 0, 0, 0, "", $return_url, 'UTF-8', 'tchinese', "測試付款", $description_schinese, $description_english, $note_tchinese, $note_schinese, $note_english, $cart_type, $cid, $cname, $caddress, $ctel, $cemail, $xtype, $xname, $xaddress, $xtel, $pcsccod_recv_store_id );

    $display = "main";

  } catch( Exception $e ) {
    $display = "error";
    $message = $e->getMessage();

  }

}

?>
<html>
<body>

<?php
switch( $display ):
/////////////////////
case 'error':
?>

Error: <?php print $message ?>

<?php
  break;
/////////////////////
case 'main':
?>

<div>

<form method="post" action="<?php print $pay_action['action_url'] ?>">
<?php foreach( $pay_action['action_param'] as $k => $v ): ?>
<?php print $k ?>: <input type="text" name="<?php print $k ?>" value="<?php print $v ?>" size="50"><br>
<?php endforeach; ?>

<input type="submit" value="submit payment">
</form>

</div>

<?php
  break;
/////////////////////
case 'result':
?>

<div>

payment result:<br>
<br>
<?php foreach( $res_param as $k => $v ): ?>
<?php print $k ?> = <?php print $v ?><br>
<?php endforeach; ?>

</div>

<?php
  break;
/////////////////////
endswitch;
?>

</body>
</html>